#include <assert.h>
#include <stdlib.h>

/* Builds a tree with parent links and
 * checks whether the values are still correct.
 */

struct node {
    struct node     *left;
    struct node     *right;
    struct node     *parent;
    int             value;
};

static void inspect(struct node *node)
{
    assert(node);
    while (node != NULL) {
        if (node->left)
            assert(node->left->value == 42);
        assert(node->value);
        node = node->parent;
    }
}

struct node *create_tree(int N)
{
    struct node *nodelast = NULL;
    struct node *node = NULL;
    while (N--) {
        node = malloc(sizeof *node);
        if (!node)
            abort();

        node->left = NULL;
        node->right = nodelast;
        if (nodelast)
            nodelast->parent = node;
        node->value = 1;
        nodelast = node;
    }
    node->parent = NULL;
    while (node != NULL) {
        node->left = malloc(sizeof *node);
        if (!node)
            abort();
        node->left->left = NULL;
        node->left->right = NULL;
        node->left->value = 42;
        node->left->parent = node;
        node = node->right;
    }
    return nodelast;
}

void free_tree(struct node *node) {
    struct node *last = NULL;
    while (1) {
        if (node->right == NULL)
            break;
        node = node->right;
    }
    while (node != NULL) {
        if (node->left)
            free(node->left);
        if (node->right)
            free(node->right);
        last = node;
        node = node->parent;
    }
    free(last);
}

int main(int argc, char *argv[])
{
    int n = atoi(argv[1]);
    struct node *data = create_tree(n);

    if (!data)
        return EXIT_SUCCESS;

    inspect(data);

    free_tree(data);

    return EXIT_SUCCESS;
}
